/*
** EPITECH PROJECT, 2019
** Buttons.hpp
** File description:
** Header file for Button classes
*/

#ifndef __BUTTONS_HPP__
# define __BUTTONS_HPP__

#include "BaseInclude.hpp"
#include "Defines.hpp"
#include "WindowCalc.hpp"

class   BaseButton : public sf::RectangleShape
{
    public:
        BaseButton(sf::Vector2f position, sf::Vector2f size);
        virtual     ~BaseButton(void) {};
        void        chargeTextures(sf::Texture *idle,
                                   sf::Texture *hover,
                                   sf::Texture *clicked);
        void        setHoverTexture(void);
        void        setClickedTexture(void);
        void        setIdleTexture(void);
    private:
    public:

    protected:
        sf::Texture *_idle;
        sf::Texture *_hover;
        sf::Texture *_clicked;
};

class   MenuButton : public BaseButton
{
    public:
        MenuButton(sf::RenderWindow *win, uint x, uint y);
        ~MenuButton(void) {};
        void    setId(const std::string &id);
        const   std::string getId(void) const;
        bool    isHovered(sf::Event &e);
        bool    clickedInside(sf::Event &e);
    private:
    public:
    private:
        std::string         _id;
};

#endif /* __BUTTONS_HPP__ */
