/*
** EPITECH PROJECT, 2020
** Dep_Olivier
** File description:
** Game
*/

#ifndef GAME_HPP_
#define GAME_HPP_

#include <list>
#include "ToolsBox.hpp"
#include "ObjectsBox.hpp"
#include "Personnage.hpp"
#include "SpaceLock.hpp"

class Game {
    public:
        Game(sf::RenderWindow *);
        ~Game();
        sf::Event   getEvent() const;
        ToolsBox    *getToolsBox() const;
        Picture *getPicture() const;
        int closeWin();
        int manageAllEvent();
        int clickOnButton(Picture *, sf::Vector2f);
        ObjectsBox  *getObjectsBox() const;
        Personnage  *getPersonnage() const;
        SpaceLock   *getSpaceLock(int) const;
        void    printPicinList();
        void    checkRepairObject(SpaceLock *);

    private:
        sf::RenderWindow  *_win;
        sf::Event   _evt;
        Picture *_background;
        ToolsBox    *_box;
        ObjectsBox  *_objects;
        Personnage  *_personnage;
        std::list<SpaceLock *> _list;
};

#endif /* !GAME_HPP_ */
