/*
** EPITECH PROJECT, 2019
** SceneManager.hpp
** File description:
** Header file for SceneManager
*/

#ifndef __SCENE_MANAGER_HPP__
# define __SCENE_MANAGER_HPP__


#include <iostream> // Debug



#include "BaseInclude.hpp"
#include "Defines.hpp"
#include "Buttons.hpp"

#include "Background.hpp"

#include "ObjectCollection.hpp"

class   SceneManager
{
    public:
        SceneManager(sf::RenderWindow *win);
        ~SceneManager(void);
        void    createMenuButton(const std::string &id, uint x, uint y,
                                 const std::string &idleTexture,
                                 const std::string &hoverTexture,
                                 const std::string &clickedTexture);
        void    initBackground(const std::string &backgroundId);
        MenuButton      *getButton(const std::string &id);
        void            drawAll(void);
        int             pollEvents(sf::Event &e);
        void            addButtonFunction(const std::string &buttonId, int code);
        std::unordered_map<std::string, int>   _buttonFunctions;
    private:
        ObjectCollection                                _objCol;
        Background                                      _background;
        std::list<MenuButton *>                         _menuButtons;
        sf::RenderWindow                                *_window;

    private:
        int             _pollButtonEvents(sf::Event &e);
        void            _buttonMoveEvent(sf::Event &e);
        int             _buttonClickEvent(sf::Event &e);
};


#endif /* __SCENE_MANAGER_HPP__ */
