/*
** EPITECH PROJECT, 2019
** Buttons.cpp
** File description:
** Buttons functions
*/

#include "Buttons.hpp"

BaseButton::BaseButton(sf::Vector2f position, sf::Vector2f size)
{
    sf::Vector2f    topLeftCorner = getPosition();
    setOrigin(size.x / 2, size.y / 2);
    setPosition(position);
    setSize(size);
    setOrigin(topLeftCorner);
    _idle = nullptr;
    _hover = nullptr;
    _clicked = nullptr;
}

void        BaseButton::chargeTextures(sf::Texture *idle,
                                       sf::Texture *hover,
                                       sf::Texture *clicked)
{
    _idle = idle;
    _hover = hover;
    _clicked = clicked;
    setIdleTexture();
}

void        BaseButton::setHoverTexture(void)
{
    setTexture(_hover);
}

void        BaseButton::setClickedTexture(void)
{
    setTexture(_clicked);
}

void        BaseButton::setIdleTexture(void)
{
    setTexture(_idle);
}

void    MenuButton::setId(const std::string &id)
{
    _id = id;
}


const   std::string MenuButton::getId(void) const
{
    return (_id);
}

MenuButton::MenuButton(sf::RenderWindow *win, uint x, uint y)
: BaseButton(WindowCalc::ratioSize(win, x, y),
             WindowCalc::ratioSize(win, 20, 15))
{
}

#include <iostream>

bool    MenuButton::isHovered(sf::Event &e)
{
    sf::Vector2f    position(e.mouseMove.x, e.mouseMove.y);
    sf::Vector2f    topLeftCorner = getPosition();
    sf::Vector2f    sizeOffset((topLeftCorner.x + getSize().x),
                               (topLeftCorner.y + getSize().y));

    return ((position.x >= topLeftCorner.x && position.x <= sizeOffset.x) &&
            (position.y >= topLeftCorner.y && position.y <= sizeOffset.y));
}

bool    MenuButton::clickedInside(sf::Event &e)
{
    sf::Vector2f    position(e.mouseButton.x, e.mouseButton.y);
    sf::Vector2f    topLeftCorner = getPosition();
    sf::Vector2f    sizeOffset((topLeftCorner.x + getSize().x),
                               (topLeftCorner.y + getSize().y));

    return (e.MouseButtonPressed && e.mouseButton.button == sf::Mouse::Left &&
            (position.x >= topLeftCorner.x && position.x <= sizeOffset.x) &&
            (position.y >= topLeftCorner.y && position.y <= sizeOffset.y));
}
