/*
** EPITECH PROJECT, 2020
** Dep_Olivier
** File description:
** SpaceLock
*/

#include <iostream>
#include "SpaceLock.hpp"

SpaceLock::SpaceLock(int id)
{
    this->_full = false;
    this->_id = id;
    this->_usable = 2;
    this->_picLock = new Picture("assets/images/game/SQUARE_LOCK.png");
    this->_picUnlock = new Picture("assets/images/game/SQUARE.png");
    this->_objInBox = nullptr;
}

SpaceLock::~SpaceLock()
{
}

int SpaceLock::getUsable() const
{
    return (this->_usable);
}

void    SpaceLock::setFull(bool newval)
{
    this->_full = newval;
}

int SpaceLock::getId() const
{
    return (this->_id);
}

bool    SpaceLock::getFull() const
{
    return (this->_full);
}

void    SpaceLock::setObjInBoxPic(Picture *pic)
{
    this->_objInBox = pic;
}

void    SpaceLock::setUsable(Personnage *perso)
{
    if (this->_usable == 5)
        return;
    switch (perso->getLevel())
    {
        case 2:
            this->_usable = 3;
            break;
        case 6:
            this->_usable = 4;
            break;
        case 13:
            this->_usable = 5;
            break;
        default:
            break;
    }
}

void    SpaceLock::displaySpace(sf::RenderWindow *window)
{
    for (int nbr = 0; nbr < 5; nbr++) {
        if (this->_usable > nbr) {
            this->_picUnlock->setPositionSprite(90, 15 + (15 * nbr));
            window->draw(this->_picUnlock->getSprite());
        }
        else {
            this->_picLock->setPositionSprite(90, 15 + (15 * nbr));
            window->draw(this->_picLock->getSprite());
        }
    }
}

Picture *SpaceLock::getObjPic(void) const
{
    return (this->_objInBox);
}